class LotIdentifierController < ApplicationController
    verify :method => :post, :only => [ :destroy, :create, :update ],
         :redirect_to => { :action => :list }
  
  def index
    list
    render :action => 'list'
  end

  def list
    @lot_identifier_pages, @lot_identifiers = paginate :lot_identifier, :per_page => 30, 
    :conditions => "(proj_id = #{@proj.id})"
  end

  def show
    @lot_identifier = LotIdentifier.find(params[:id])
  end

  def new
    @lot_identifier = LotIdentifier.new
  end

  def create
    @lot_identifier = LotIdentifier.new(params[:lot_identifier])
    if @lot_identifier.save
      flash[:notice] = 'LotIdentifier was successfully created.'
      redirect_to :action => 'list'
    else
      render :action => 'new'
    end
  end

  def edit
    @lot_identifier = LotIdentifier.find(params[:id])
  end

  def update
    @lot_identifier = LotIdentifier.find(params[:id])
    if @lot_identifier.update_attributes(params[:lot_identifier])
      flash[:notice] = 'LotIdentifier was successfully updated.'
      redirect_to :action => 'show', :id => @lot_identifier
    else
      render :action => 'edit'
    end
  end

  def destroy
    LotIdentifier.find(params[:id]).destroy
    redirect_to :action => 'edit', :controller => 'lot', :id => params[:lot_id]
  end
end
