class PartController < ApplicationController
  relation_browser :part
  
  verify :method => :post, :only => [ :destroy, :create, :update ],
         :redirect_to => { :action => :list }
  
  def index
    list
    render :action => 'list'
  end

  def list
    @part_pages, @parts = paginate :part, :per_page => 30, :conditions => "(proj_id = #{@proj.id})"
  end

  def show
    id = params[:part][:id] if params[:part]
    id ||= params[:id]
    @part = Part.find(id)
  end

  def new
    @part = Part.new
  end

  def create
    @part = Part.new(params[:part])
    if @part.save
      flash[:notice] = 'Part was successfully created.'
      redirect_to :action => 'list'
    else
      render :action => 'new'
    end
  end

  def edit
    @part = Part.find(params[:id])
  end

  
  def terms
    @term = Part.find(:all)
  end

  def update
    @part = Part.find(params[:id])
    if @part.update_attributes(params[:part])
      flash[:notice] = 'Part was successfully updated.'
      redirect_to :action => 'show', :id => @part
    else
      render :action => 'edit'
    end
  end

  # duped in Ontology::destroy_term
  # logic should be in model
  def destroy
    p = Part.find(params[:id])
    if session[:person].id.to_i == p.creator_id.to_i || session[:person].is_admin
      begin
        p.destroy
        flash[:notice] = "Part deleted."
      rescue
        flash[:notice] = "Can't deleted part, it is being used elsewhere."
      end
    else
      flash[:notice] = "Can't deleted  parts you didn't create"
    end
    redirect_to :action => 'index'
  end

  def clone_from_project
    if p = Proj.find(params[:proj][:id])
      c = Part.clone_from_project(p.id)
      flash[:notice] = "Successfully cloned #{c} parts from project #{p.id}."
      redirect_to :action => 'show', :controller => "proj", :id => p.id
    end  
  end
  
  def terms
    @part = Part.find(:all, :conditions => ["proj_id = '32'"])
  end

  def auto_complete_for_part
    @tag_id_str = params[:tag_id]
    
    if @tag_id_str == nil
      redirect_to(:action => 'index', :controller => 'ontology') and return
    else
       
      value = params[@tag_id_str.to_sym].split.join('%') # hmm... perhaps should make this order-independent
 
      lim = case params[@tag_id_str.to_sym].length
        when 1..2 then  10
        when 3..4 then  25
        else lim = false # no limits
      end 
      
      @parts = Part.find(:all, :conditions => ["(name LIKE ? OR id = ? OR obo_dbxref LIKE ?) AND proj_id=?", "%#{value}%",  value.gsub(/\%/, ""),"%#{value}%",  @proj.id], :order => "length(name)", :limit => lim )
    end
    
    render :inline => "<%= auto_complete_result_with_ids(@parts,
      'format_part_for_auto_complete', @tag_id_str) %>"
  end


end
