class ProjController < ApplicationController
  # @proj is set by a 'before_filter'
  
  verify :method => :post, :only => [ :destroy, :create, :update ],
         :redirect_to => { :action => :list }

  def index
    list
    render :action => 'list'
  end

  def list
    # project membership is checked in a filter as well
    @page_title = "Choose a project"

    person = Person.find($person_id)
    @all_projs = Proj.find(:all, :order => 'name')
    @persons_projs = person.projs.collect{|p| p.id}
    @is_admin = person.is_admin
  
    # session['group_ids'] = {} # should also be set in environment likely (testing)
    # session[:multikey] = nil
    @news = News.current_app_news
  end

  def show
    @page_title = @proj.name
    
    # for cloning parts from another project
 
  end

  # see admin_controller for creating new projects
  
  def edit
    @proj = Proj.find(params[:id])
    @people = Person.find(:all, :order => 'login')
    @target = 'update' # GET RID OF THIS!
    # @users_projs_with_parts = Person.find($person_id).projects_with_parts(@proj.id)
    @pub_controllers = []

    @pub_controllers = Dir.glob(File.join("#{RAILS_ROOT}/app/controllers/public", "*_controller.rb")).collect {|f| File.basename(f, "_controller.rb")} #  <% for c in Dir.entries["#{RAILS_ROOT}/app/controllers/public/[a-z]*"].collect {|f| File.basename(f, "_controller.rb")} %> 
    @pub_controllers.push "site/#{@proj.unix_name}/home" if Dir.glob(File.join("#{RAILS_ROOT}/app/controllers/public/site/#{@proj.unix_name}", "*_controller.rb")).collect {|f| File.basename(f, "_controller.rb")}.size > 0
  end

  def update
    @proj = Proj.find(params['id'])

    if @proj.update_attributes(params['proj'].merge(
      {'hidden_tabs' => make_ar('hidden_tabs'), 'public_controllers' => make_ar('public_controllers')}))
      @proj.people.clear
      @people = Person.find(:all)
      for person in @people                       # if it is saved we can add the people-projects links
        if (params[:people][person.login])        # if a login is in params it is because the user checked that box
          @proj.people<<(person)                  # so we insert the person in the collection using the '<<' method
        end
      end
      session[:proj] = nil # forces the project stored in the session to be freshly loaded next time
      flash[:notice] = 'Proj was successfully updated.'
      redirect_to :action => 'show', :id => @proj.id
    else
      @people = Person.find(:all)
      @target = 'update'
      render :action => 'edit'
    end
  end

  def destroy
    # can only be destroyed by creator or admin which is set on logon
    p = Proj.find(params[:id])
    
    if p && p.nuke($person_id)
      flash[:notice] = "Destroyed the project."
    else
      flash[:notice] = "Failed to destroy the project, contact an adminstrator."
    end

    redirect_to :controller => '/proj', :action => 'list'
  end

  def summary
    @klass = "Proj"
    @proj = Proj.find(params[:id])
  end

  def my_data
    if request.post?
      @foo = @proj.csv_string(:klass => params[:klass].constantize)
      send_data @foo, :type => "text/plain", :filename=> "project_#{@proj.id}_#{params[:klass]}_#{Time.now.day}_#{Time.now.month}_#{Time.now.year}.csv", :disposition => 'attachment' and return
    #  render :nothing => true
    end

  end


  private

  # meh this is odd 
  def make_ar(thing)
    ar = []
    params[thing].each_pair {|k,v| ar << k } if params[thing]
    ar
  end

end
