require 'ontology/ontology_methods'

class Public::OntologyController < Public::BaseController

  verify :method => :post, :only => [ :destroy_term, :destroy_relationship, :create, :update, :search ],
  :redirect_to => { :action => :index }

  def index 
   # @total_terms = @proj.parts.is_public.count
  #  @term = Part.new()
  #  @parts = @proj.parts.is_public
    
  end

  def search
      respond_to do |format|
        format.html {
          if @ontology_class = OntologyClass.find(params[:search][:ontology_class_id])
            render :action => :show 
          else
            flash[:notice] = "Can't find that result, did you select an item from the picklist?"
            redirect_to :action => :index 
          end
        }  
        format.js {  # a search request
      
          @result = OntologyMethods.search_result(params.merge!(:proj_id => @proj.id))
     
          render :update do |page|
                          
            # page << "if($('ontology_class_labels_for_id#{id_to_find}')) {"   # have a sensu list on the page?
            page.replace_html "search_result", :partial => 'search_result'
            # page << "}"
          end
        }
      end
    end
  
  def show_term
  
  end

  def show_random
    redirect_to :action => :show_term
  end
  
  def show_contributors

    redirect_to :action => :show_term and return
    # TODO: move this to models
    @pids = (Part.find_by_sql(["Select distinct creator_id i from parts where proj_id = ?;", @proj.id]) + 
             Part.find_by_sql(["Select distinct updator_id i from parts where proj_id = ?;", @proj.id]) +
             Ontology.find_by_sql(["Select distinct creator_id i from ontologies where proj_id = ?;", @proj.id]) +
             Ontology.find_by_sql(["Select distinct updator_id i from ontologies where proj_id = ?;", @proj.id]))
             
    @people = Person.find(@pids.collect{|o| o.i}, :order => 'last_name')

    # could do this in some crosstab I'm sure but...
    @result = HashFactory.call
    for p in @people
      @result[p.full_name][:part][:creator] = Part.find(:all, :conditions => "creator_id = #{p.id} and proj_id = #{@proj.id}").size
      @result[p.full_name][:part][:updator] = Part.find(:all, :conditions => "updator_id = #{p.id} and proj_id = #{@proj.id}").size
      @result[p.full_name][:ont][:creator] = Ontology.find(:all, :conditions => "creator_id = #{p.id} and proj_id = #{@proj.id}").size
      @result[p.full_name][:ont][:updator] = Ontology.find(:all, :conditions => "updator_id = #{p.id} and proj_id = #{@proj.id}").size
      @result[p.full_name][:fig][:creator] = Figure.find(:all, :conditions => "creator_id = #{p.id} and proj_id = #{@proj.id}").size
      @result[p.full_name][:fig][:updator] = Figure.find(:all, :conditions => "updator_id = #{p.id} and proj_id = #{@proj.id}").size
      @result[p.full_name][:tag][:creator] = Tag.find(:all, :conditions => "creator_id = #{p.id} and proj_id = #{@proj.id}").size
      @result[p.full_name][:tag][:updator] = Tag.find(:all, :conditions => "updator_id = #{p.id} and proj_id = #{@proj.id}").size
    end
  end
  
  def _markup_definition
     if @term = Part.find(params[:id])
       if @term.description.size == 0
          render(:text => '<i>no definition to markup</i>', :layout => false)
        else
          @l = Linker.new(:proj_id => @proj.ontology_id_to_use, :incoming_text => @term.description, :adjacent_words_to_fuse => 5)
          render(:text => RedCloth.new(@l.linked_text(:is_public => 2, :exclude_blank_descriptions => true)).to_html, :layout => false ) 
        end
     else
      flash[:notice] = "Something went wrong when trying to markup a definition."
      render :action => 'index'
    end
  end
 
  def proof
    redirect_to :action => :show_term and return
    respond_to do |format|
        format.html { 
        }
        format.js {
          render :update do |page|
            @l = Linker.new(:proj_id => @proj.ontology_id_to_use, :incoming_text =>  truncate(params[:txt].to_s, 1000, '...').to_s, :adjacent_words_to_fuse => 5)
            page.replace_html :proofed_text, :partial =>  'proofed'
          end and return
        }
    end      
  end

  # API style specific to a public ontology
  
 # def search
 #  # this 
 ##  base_url =  ('http://' + (ENV['RAILS_ENV'] == 'production' ? HOME_SERVER : '127.0.0.1:3000') + "/projects/#{@proj.id}/public/ontology/metadata")
 ##  if @term = Part.is_public.find_by_name(params[:id])
 ##    render :layout => false, :text => "#{base_url}/#{@term.id}" and return
 ##  else
 ##    render :layout => false, :text =>  "#{base_url}/0" and return
 ##  end
 ## end

 #def embed
 #  base_url =  ('http://' + (ENV['RAILS_ENV'] == 'production' ? HOME_SERVER : '127.0.0.1:3000') + "/projects/#{@proj.id}/public/ontology/metadata")
 #  if @term = Part.is_public.find_by_name(params[:id])
 #    @l = Linker.new(:proj_id => @proj.ontology_id_to_use, :incoming_text => @term.description, :adjacent_words_to_fuse => 5)
 #    @relationships = @term.relationships
 #    render :layout => false, :partial => "embed" and return
 #  else
 #    render :layout => false, :text =>  "The term '#{params[:id]}' is not in the database." #{base_url}/0" and return
 #  end
 #end

 #def metadata
 #  if @term = Part.is_public.find(params[:id])
 #    render :layout => false, :text => @term.to_xml and return
 #  else
 #    render :layout => false, :text => 'something bad here' and return
 #  end
 #end
 #
 ## (simplified) Tree viewing

 ## it's recursive, and we keep track of a lot of metadata, so there is lots of :locals use
 #def tree
 #  redirect_to :action => :index and return
 #  if !params[:id].blank?
 #    @treetop = @proj.parts(:conditions => {:id => params[:id]}).first
 #  else
 #    @treetop = @proj.default_ontology_term
 #  end 
 #  @proj.parts.first if !@treetop
 #  redirect_to :action => :index and return if !@treetop 
 #  @colored_isas = @proj.isas.with_color_set
 #  @all_isas = @proj.isas 
 #end

 #def _tree_set_root
 #  render :layout => false, :nothing => true and return if !params[:ontology]
 #  @treetop = Part.find(params[:ontology][:part_id])
 #  render :layout => false, :partial => '/public/ontology/tree_index', :locals => { :relationship_type => ((params[:isa] && params[:isa][:id] && !params[:isa][:id].blank?) ? params[:isa][:id]  : 'all' ), :max_depth => (params[:max_depth].to_i || 2)}
 #end 

 ## open and close a node
 #def _tree_navigate_through_child
 #  @part = Part.find_by_id(params[:id])
 #  
 #  @isa = Isa.find(params[:parent_relationship]) if !params[:parent_relationship].blank?
 #  @isa == 'root' if !@isa 
 # 
 #  # close 1 1;  open 0 1; open false (close); true (open) 
 #  render :update do |page|
 #    page.replace "level_#{@part.id}", :partial => '/public/ontology/tree_recurser', :locals => {
 #      :level => (params[:close] ? 1 : 0),
 #      :max_depth => 1,
 #      :parent_node => @part,
 #      :open => (params[:close] ? false : true),
 #      :relationship => @isa,
 #      :relationship_type => params[:relationship_type] }

 #  end and return        
 #end

 #protected

 #def _show_params
 #  @relationships = @term.relationships
 #  session['ont_view']  = 'show_term'
 #  @show = ('show_term') # not redundant with above- @show necessary for multiple display of items 
 #  @no_right_col = true
 #  @l = Linker.new(:proj_id => @proj.ontology_id_to_use, :incoming_text => @term.description, :adjacent_words_to_fuse => 5)
 #  @figures = @term.figures
 #  @tags = @term.tags
 #  @synonymous_children = @term.synonymous_children
 #  @synonymous_with = @term.synonymous_with

 #  render :action => 'show_term'
 #  true
 #end

end



