class Public::PublicContentController < Public::BaseController

  def index
    list
    render :action => 'list'
  end

  def list
   @otus = @proj.published_otus 
  end

  def show
    @public = true
    @otu = Otu.find(params[:id])
    
    @content_template = ContentTemplate.find(params[:content_template_id]) if !params[:content_template_id].blank?

    if @proj.default_content_template.blank? && !@content_template
      flash[:notice] = "You haven't set a default template for this project. Adjust your settings."
      redirect_to :action => :list
    end

    @content_template = @proj.default_content_template if !@content_template
    @otu_cons = @otu.public_contents # at present we just show it all

  end

  def _markup_description
     if @o = Content.find(params[:id]) # there is always text otherwise header wont' be shown
       @l = Linker.new(:proj_id => @proj.ontology_id_to_use, :incoming_text => @o.text, :adjacent_words_to_fuse => 5, :public_server_name => @proj.public_server_name)
          render(:text => RedCloth.new(@l.linked_text(:is_public => true, :exclude_blank_descriptions => true)).to_html, :layout => false ) # htmlize from application_helper not available here
      else
      flash[:notice] = "Something went wrong when trying to markup a definition."
      render :action => 'index'
    end
  end
 
  # KLM literal coming
  def show_kml_text
    @otu = Otu.find(params[:id])
    render :layout => false, :template => '/otu/show_kml_text'
  end

end
