class Public::RefController < Public::BaseController
  
  def index
    list
    render :action => 'list'
  end
  
  def list
    if params['sort'] == 'full_citation'
       s = 'full_citation'
    else
     s = 'year' 
   end
   @ref_pages, @refs = paginate :ref, { :per_page => 15, :include => :projs,
       :conditions => [ 'projs.id =?', @proj ], :order => s }
    @sort = s
  end
  
  def show
    # should project check some how, or not...
    if params[:id] != nil && @ref = Ref.find(params[:id], :include => [:taxon_names, :projs])
    else
      flash[:notice] = "can't find that reference!"
      redirect_to :action => 'list'
    end
  end

  # ugh, model to :named_scope
  def list_by_author 
    if params[:name]
      @refs = Ref.find_by_sql(["SELECT refs.*, authors.last_name
                FROM refs LEFT JOIN authors ON refs.id = authors.ref_id
                LEFT JOIN projs_refs ON refs.id = projs_refs.ref_id
                LEFT JOIN projs ON projs.id = projs_refs.proj_id
                WHERE authors.last_name = ? AND projs.id = ? 
                GROUP BY refs.id ORDER BY authors.last_name", params[:name], @proj])
      @target = 'name'
        
    else
      params[:letter] = 'A' if not params[:letter]    
      @refs = Ref.find_by_sql(["SELECT COUNT(refs.id) AS total, authors.last_name
                FROM refs LEFT JOIN authors ON refs.id = authors.ref_id
                LEFT JOIN projs_refs ON refs.id = projs_refs.ref_id
                LEFT JOIN projs ON projs.id = projs_refs.proj_id
                WHERE authors.last_name LIKE ? AND projs.id = ? 
                GROUP BY authors.last_name ORDER BY authors.last_name", "#{params[:letter]}%", @proj])   
     @target = 'letter'                        
    end  
  end

end
