module AutocompleteHelper
  ### auto_complete formatting (h is turned off in mx) 
  
  # AJAX, for use in all search dropdowns
  def auto_complete_result_with_ids(entries, format_method, id_str)
    return unless entries
    items = entries.map { |entry| content_tag("li", self.send(format_method, entry), "id" => "#{id_str}::#{entry.id}") }
    items << content_tag("li", "-- none --", "id" => "#{id_str}::::")
    content_tag("ul", items)
  end

  # AJAX, for use in all search dropdowns
  def auto_complete_result_with_ids_and_class(entries, format_method, id_str)
    return unless entries
    items = entries.map { |entry| content_tag("li", self.send(format_method, entry), "id" => "#{entry.class.name}::#{entry.id}") }
    items << content_tag("li", "-- none --", "id" => "#{id_str}::::")
    content_tag("ul", items)
  end

  def format_ontology_result_for_auto_complete(o)
    case o.class.name
    when "Label"
       content_tag('div', o.name, :class => 'ont_label', :style => 'padding: 2px;')
    when "OntologyClass"
       content_tag('div', o.definition, :class => 'ont_class', :style => 'padding: 2px;')
    when "Tag"
      content_tag('div', o.display_name, :class => 'ont_tag', :style => 'padding: 2px;')
    else
      content_tag('em', 'error', :class => 'failed')
    end 
  end

  # if you just use display_name in the picker you can use this method in the controller...erm this should not be needed?!
  def format_obj_for_auto_complete(o)
    o.display_name(:type => :select)
  end

  # TODO: deprecate all these for Obj#display_name(:type => select) 
  # DEPRECATE
  def format_image_description_for_autocomplete(o)
    o.display_for_ajax_dropdown 
  end
  
  # DEPRECATE
  def format_geog_for_auto_complete(geog)
    n = geog.name
    if geog.geog_type
      n << content_tag("span", " [#{geog.geog_type.name}]", "class" => "tnParent")
      n << " #{geog.state.name}" if (geog.state and (geog.geog_type.name != 'state'))  
      n << " #{geog.country.name}" if (geog.country and geog.geog_type.name != 'country') 
    else
      n << 'foo'
    end
    n # required, or it barfs - very odd
  end

  # DEPRECATE
  def format_repository_for_auto_complete(rep)
    truncate(rep.display_name, 90)
  end

  # DEPRECATE  
  def format_serial_for_auto_complete(serial)
    "#{serial.name}  <span class=\"small_grey\">(id: #{serial.id})</span>"
  end

  # DEPRECATE
 def format_part_for_auto_complete(part)
    "#{part.name}  <span class=\"small_grey\"><i>id:</i>#{part.id}" + (part.obo_dbxref.blank? ? '' : "; <i>xref:</i>#{part.obo_dbxref}") + (part.ref.blank? ? '' : "; <i>auth:</i>#{part.ref.authors_year}") + "</span>"
  end

  # DEPRECATE
  def format_taxon_name_for_auto_complete(tn)
    if tn.valid_name_id.blank? 
      tn.display_for_select + " " + content_tag("span", tn.parent_name, "class" => "tnParent")
    else
      "<span style=\"color:red;\">#{tn.display_for_select} ( =" + content_tag("span", tn.valid_name.display_for_select) + " " + content_tag("span", tn.valid_name.parent.display_for_select, "class" => "tnParent")  + ')</span>'
    end
  end
  
end
