module ContentHelper

  # links the text between tags as below to their respective instances 
  # <otu id="234"> </otu> 
  def link_otus(text)
    if text["<otu"]
      text.gsub(/<otu\s+id=\"(\d+)\">([^<]+)<\/otu>/) {|s| link_to $2, :controller => 'otu', :action => 'show', :id => $1}
    else
      text
    end
  end

  # links the text between tags as below to their respective instances 
  # <ref id="234"> </ref> 
  def link_refs(text)
    if text["<ref"]
      text.gsub(/<ref\s+id=\"(\d+)\">([^<]+)<\/ref>/) {|s| link_to $2, :controller => 'ref', :action => 'show', :id => $1}
    else
      text
    end
  end

  # chains all link_ methods
  def tags_to_links(text)
    link_refs(link_otus(text))
  end 


end
