module FigureHelper

  def thumbnail_with_svg_tag(figure)
    content_tag(:div, :id => "figure_#{figure.id}_img", :class => 'image') do 
      if figure.figure_markers.size > 0
        update_page_tag do |page|
          page.call 'createSvgObjRoot', (request.xml_http_request? ? 'ajax' : 'http'), *figure.svgObjRoot_params(:thumb)
        end
      else
        image_thumb_tag(figure.image)
      end
    end 
  end

  def caption_tag(figure)
    content_tag :div, :style => "text-align: left; width: #{figure.image.width_for_size(:thumb).to_i}px; height: 2em;" do
      figure.position.to_s + "." + expandable_caption((figure.caption.blank? ? '' : figure.caption), figure.id, figure.text_width_chrs) 
    end 
  end

  def link_to_figured(figure, link_text = 'show')
    return "<strong style='color:red'>ERROR? #{figure.addressable_type}:#{figure.addressable_id}</strong>" if !figure.figured_obj
    link_to(link_text, :action => :show_figures, :id => figure.addressable_id, :controller => figure.addressable_type.underscore) 
  end

  def figured_object_tag(figure)
    [content_tag(:span, figure.addressable_type), 
      content_tag(:span, "id:" + figure.addressable_id.to_s),
      content_tag(:span, figure.figured_obj ? figure.figured_obj.display_name : '<strong style="color:red;">ORPHANED FIGURE</strong>'),
      link_to_figured(figure) 
    ].join("<br />")
  end 

  # handles the <script wrapper>
  def svg_tag(options = {})
    opt = {
      :figure => nil,
      :target => ""
    }.merge!(options.symbolize_keys)

    return nil if opt[:figure].nil?

    xml = Builder::XmlMarkup.new(:indent=> 2, :target => opt[:target])

    xml.script(:type => 'image/svg+xml') {
      opt[:figure].svg(opt) 
    }

    # this might need better logic for IE
    # see http://github.com/imanel/svg_web/blob/master/lib/svg_web.rb
    #   xml.script(:type => 'image/svg+xml') {

    #   }

    opt[:target].to_s 
  end

  def fig_link(o)
    render(:partial => "figure/fig_link", :locals => { :fig_obj_id => o.id, :fig_obj_class => o.class.to_s, :msg => ''})
  end

  def render_figs_for_obj(o, size = 'thumb', render_w_no_figs = true, klass = 'attached_figs', mb_annotation = false, mode = 'partial')
    @obj = o
    @size = size
    @klass = klass
    @mb_annotation = mb_annotation
    @figures = @obj.figures

    # MODE IS A HACK

    # hmm- this needs to be :partial in some case, :templates in others?
    if mode == 'js'
      render(:template => '/figure/attached_figures') if render_w_no_figs || @figures.size > 0
    else
      render(:partial => '/figure/attached_figures') if render_w_no_figs || @figures.size > 0
    end

  end

end
