# Methods added to this helper will be available to all templates in the application.
module LayoutHelper

  # various layout configurations

  # include a css file for a specific class if it exists (also bad for hitting files)
  # TODO: memoize this?!
  def class_css
    if File.exist?("#{RAILS_ROOT}/public/stylesheets/class/#{self.controller.controller_name}.css") 
      "<link rel=\"Stylesheet\" href=\"/stylesheets/class/#{self.controller.controller_name}.css\" type=\"text/css\" />"
    end
  end

  def needs_accordion
    # you must include the controller\/method in the array below to load accordion.js
    needs = ['otu\/show_material', 'otu\/show_tags', 'public\/multikey\/show_tags', 'ontology\/show_term_tags', 'ce\/show_material', 'taxon_name\/show_tags', 'keyword\/show_tags'].join("|")
    return true if !self.url_for.grep(/#{needs}/).empty?
    false
  end
  
  def needs_gmaps
    needs = ['otu\/show_map', 'lot/show', 'public\/public_content\/show', '\/otu\/show_content','\/ce\/new_from_gmap','\/ce\/show', 'content_template\/show_page', 'specimen\/show'].join("|")
    return true if !self.url_for.grep(/#{needs}/).empty?
    false
  end
 
  def needs_colorPicker
    needs = ['person\/preferences', 'object_relationship\/new', 'object_relationship\/edit', 'object_relationship\/create','keyword\/new', 'confidence\/new', 'confidence\/edit', 'keyword\/edit', 'keyword\/create', 'confidence\/create' ].join("|")
    return true if !self.url_for.grep(/#{needs}/).empty?
    false
  end
  
  # subnav on/off
  def no_subnav
    ['account', 'proj', 'admin', 'doc' ]
  end

  # subnav sidenav (class nav) on/off, is off if no subnav
  def no_sidenav
    ['public_content', 'image_description', 'figure', 'multikey'] 
  end
  
  # determines whether or not to render a picker in the sidenav, remove as pickers are built, is redundant if no_sidenav true
  def no_pickers
    ['person', 'association','chromatogram','morphbank_image', 'distribution', 'object_relationship', 'news', 'measurement', 'ontology', 'protocols', 'tag'] 
  end
  
  # toggles new and list buttons in the top right blue box
  def no_new_or_list
    ['tag', 'content','morphbank_image', 'person', 'ontology']
  end
  
end
