# == Schema Information
# Schema version: 20090930163041
#
# Table name: lot_identifiers
#
#  id           :integer(4)      not null, primary key
#  lot_id       :integer(4)      not null
#  identifier   :string(64)
#  namespace_id :integer(4)      not null
#  creator_id   :integer(4)      not null
#  updator_id   :integer(4)      not null
#  updated_on   :timestamp       not null
#  created_on   :timestamp       not null
#

class LotIdentifier < ActiveRecord::Base
  has_standard_fields
  
  belongs_to :lot
  belongs_to :namespace

  
  validates_presence_of :lot, :namespace, :identifier
  
  def display_name(options = {})
    s = self.identifier
    s << '<span class="small_grey">&nbsp;' + self.namespace.name + '</span>'
  end
  
end
