# == Schema Information
# Schema version: 20090930163041
#
# Table name: namespaces
#
#  id             :integer(4)      not null, primary key
#  name           :string(255)     not null
#  owner          :string(255)
#  notes          :text
#  url_access     :text
#  short_name     :string(6)
#  last_loaded_on :datetime
#  creator_id     :integer(4)      not null
#  updator_id     :integer(4)      not null
#  updated_on     :timestamp       not null
#  created_on     :timestamp       not null
#

class Namespace < ActiveRecord::Base
  has_standard_fields
  
  has_many :refs
  has_many :taxon_names
  has_many :lot_identifiers
  has_many :specimen_identifiers

  after_save :update_specimen_identifier_cached_display_name

  # has_many :ces <- but not sure we want this
  def display_name(options = {})
    name
  end

  # TODO: deprecate for display_name
  def display_for_select
    name
    # str = name #  "[" + coden + "] " if coden != "" 
    # str << " " + name if name != ""
  end

  def self.auto_complete_search_result(params = {})
    tag_id_str = params[:tag_id]
    return false if (tag_id_str == nil  || params[:proj_id].blank?)

    value = params[tag_id_str.to_sym].split.join('%') 

    lim = case params[tag_id_str.to_sym].length
          when 1..2 then 3 
          when 3..4 then 5 
          else lim = false # no limits
          end 
    Namespace.find(:all, :conditions => ["(namespaces.name LIKE ? OR namespaces.short_name LIKE ? OR namespaces.id = ?)", "%#{value}%", "%#{value}%", value.gsub(/\%/, "") ], :limit => lim, :order => 'name' )
  end
 
  protected
  
  def update_specimen_identifier_cached_display_name
    self.specimen_identifiers.each do |si|
      si.save!
    end
    true
  end
    
end
