class ObjectRelationship < ActiveRecord::Base
  has_standard_fields  

  acts_as_list :scope => :proj
  belongs_to :proj
  has_many :association_parts
  ## validates_uniqueness_of (:interaction, :complement) , :scope => 'proj_id' # need combination of these

  # all the isas used in ontologies where part2_id is used
  # named_scope :by_child_part, lambda {|*args|  {:conditions => ["isas.id IN (SELECT isa_id from ontologies where part2_id = ?)", args.first || -1] }} 
    
  named_scope :with_color_set, {:conditions => 'html_color IS NOT null AND html_color != ""'}
  named_scope :not_isa, {:conditions => "interaction != 'is_a'"}
  named_scope :by_interaction, lambda {|*args| {:conditions => ["interaction = ?",  (args.first || -1)]}}

  validates_presence_of :interaction

  def display_name(options = {})
    "#{interaction} / #{complement}"
  end

  # TODO deprecate, xml or helper or display_name
  def colored_display_name
    html_color.blank? ? "#{interaction} / #{complement}": "<div style=\"display: inline; background: ##{html_color}; padding: 0px .2em;\">#{interaction} / #{complement}</div>"  
  end

  def object_relationship_link_for_show(params = {})
    opts = {
      :div_id => 'new_object_relationship'
    }.merge!(params)

    content_tag :div, link_to_remote("Add relationship", :url =>  opts.merge(:action => :new, :controller => :object_relationship) ), :id => opts[:div_id] 
  end

end
