# == Schema Information
# Schema version: 20090930163041
#
# Table name: protocols
#
#  id          :integer(4)      not null, primary key
#  kind        :string(10)
#  description :text
#  proj_id     :integer(4)      not null
#  creator_id  :integer(4)      not null
#  updator_id  :integer(4)      not null
#  updated_on  :timestamp       not null
#  created_on  :timestamp       not null
#

class Protocol < ActiveRecord::Base
  has_standard_fields
  has_many :pcrs, :dependent => :nullify
  has_many :primers, :dependent => :nullify
  has_many :chromatograms, :dependent => :nullify
  has_many :extracts, :dependent => :nullify

  has_many :protocol_steps, :dependent => :destroy

  validates_presence_of :description
  
  def self.kind
    ["extraction", "chromatogram", "clean", "PCR", "other" ]
  end

  def display_for_select
    self.description
  end

  def display_name(options = {})
    description
  end

end
