# Because refs are shared between projects, this model handles the 
# notification of changes that could affect other projects.
class RefMailer < ActionMailer::Base
  
  def update_notice(ref, diff_hash, recipient, project)    
    recipients recipient.email
    from       "ref_notifier@#{HOME_SERVER}"
    subject    "Reference '#{ref.short_citation}' was updated by #{Person.find($person_id).full_name}"
    body       :diff_hash => diff_hash, :ref => ref, :recipient_person => recipient, :project => project
  end
  
  def taxon_name_notice(new_ref, old_ref, recipient)
    recipients recipient.email
    from       "ref_notifier@#{HOME_SERVER}"
    if new_ref
      subject    "Please verify duplicate reference '#{old_ref.short_citation}'"
    else
      subject    "Please verify deletion of reference '#{old_ref.short_citation}'"
    end

    body :new_ref => new_ref, :old_ref => old_ref, :recipient_person => recipient, :updator => Person.find($person_id)
  end
  
end
