# == Schema Information
# Schema version: 20090930163041
#
# Table name: type_specimens
#
#  id            :integer(4)      not null, primary key
#  specimen_id   :integer(4)      not null
#  taxon_name_id :integer(4)      not null
#  type_type     :string(24)
#  notes         :text
#

class TypeSpecimen < ActiveRecord::Base

  belongs_to :specimen
  belongs_to :taxon_name

  validates_uniqueness_of :specimen_id, :scope => :taxon_name_id, :allow_nil => true
  validates_presence_of :type_type
  validates_presence_of :specimen

  # CAREFUL not required - pre publication indication of type status should be possible
  # validates_presence_of :taxon_name

  named_scope :with_type_status, lambda {|*args| {:conditions => ["type_type = ?", (args.first || -1)] }}
  named_scope :without_taxon_name_assignment, :conditions => "specimen_id is null"
  named_scope :with_taxon_name_assignment, lambda {|*args| {:conditions => ["taxon_name_id = ?", (args.first || -1)] }}


end
