
# Set your local ip/server root here, if you are only running in test
# or development mode this doesn't need to be set
HOME_SERVER = 'foo.bar.com'
MAIL_SERVER = 'foo.bar.com'
HELP_WIKI = 'foo.bar.com/wiki'

# Supply the path to ImageMagik's 'identify' and 'convert' binaries
IMAGE_MAGICK_PATH = '/usr/local/bin/'

# for storing content files we use a symbolic link (public/files) that points to 
# a folder outside of the rails directory, so that it is
# not under version control, and is easier to back up, etc.
FILE_PATH = "#{RAILS_ROOT}/public/files/"
WEB_PATH = "/files/"

TEMP_FILE_PATH = "#{FILE_PATH}temp/"

IMAGE_FILE_PATH = "#{FILE_PATH}images/"
IMAGE_WEB_PATH = "#{WEB_PATH}images/"

CHROMATOGRAPH_FILE_PATH = "#{FILE_PATH}chromatographs/"
CHROMATOGRAPH_WEB_PATH = "#{WEB_PATH}chromatographs/"

GEL_IMAGE_FILE_PATH  = "#{FILE_PATH}gel_images/"
GEL_IMAGE_WEB_PATH = "#{WEB_PATH}gel_images/"

# for database backup/reload script (db/Rakefile)
DATA_DIR = "#{RAILS_ROOT}/db/dumps/"

# An array of admin's email addresses for error and sanitizer emails
NOTIFICATION_RECIPIENTS = ['foo@bar.com']

# for error mails (see plugins/exception_notification/README for more options)
ExceptionNotifier.exception_recipients = NOTIFICATION_RECIPIENTS
ExceptionNotifier.sender_address = %("Application Error" <error@#{HOME_SERVER}>)

# this is a found fix for ExceptionNotifier, it works (July 3, 2008)
ExceptionNotifier.class_eval do
  remove_method :template_root
  ExceptionNotifier.template_root =  "#{RAILS_ROOT}/vendor/plugins/exception_notification/lib/../views"
end

# add your gmaps key here
GMAPS_KEY_PRODUCTION = 'get a key at the Google maps api site'
GMAPS_KEY_DEVELOPMENT = 'get ANOTHER key at the Google maps api site'

# Common words (excluded as an option in Ontology proofing/parsing
COMMON_WORDS = File.read("#{RAILS_ROOT}/config/common_words.txt").split("\n").uniq!.sort

## Application Layout Constants ##
# tabs/subnav can be reconfigured here if you want to hide or rearange things

# TABS = ["otu", "chr", "mx", "content", "specimen", "seq", "ref", "association",  "taxon_name", "image", "ontology", "clave", "tag", "tree"]
# TAB_SUBNAV = YAML.load_file("#{RAILS_ROOT}/config/tabs.yaml")
# LAYOUT = YAML.load_file("#{RAILS_ROOT}/config/layout.yaml")
