ActionController::Routing::Routes.draw do |map|
  # map.resources :ontology, :path_prefix => '/projects/:proj_id/public', :controller => 'public/ontology'
  # map.connect '/projects/:proj_id/:controller/:action.:format'

  # help pages
  # DEPRECATED
  # map.connect '/projects/:proj_id/doc/show_for/:controller_name', :controller => 'doc', :action => 'show_for'
  
  # matrix/coding routes
  map.connect '/projects/:proj_id/:controller/fast_code/:id/:mode/:position/:otu_id/:chr_id/:chr_state_id', :action => 'fast_code'  # mode is row or col
  map.connect '/projects/:proj_id/:controller/fast_code/:id/:mode/:position/:otu_id/:chr_id', :action => 'fast_code' 
  map.connect '/projects/:proj_id/:controller/code/:id/:otu_id/:chr_id', :action => 'show_code' # for cell clicks
 
  # associations
  map.connect '/projects/:proj_id/:controller/:action/association/:association_id/:id',
    :requirements => {  :proj_id => /\d+/,
                        :id => /\d+/}
  
  # content
  map.connect '/projects/:proj_id/:controller/:action/:id/:con_template_id',
      :requirements => {:proj_id => /\d+/,
                        :id => /\d+/,
                        :con_template_id => /\d+/}

  # handle project controller prefix (this is hit on public requests)
  map.connect 'projects/:proj_id/:controller/:action/:id', 
    :controller => 'proj'

  # Install the default route as the lowest priority.
  # this handles just :controller and :controller/:action as well
  # the proj part on the end says that if the controller was not specified in the request
  # (i.e. ''), call the proj controller (the index action is default for it)
  map.connect ':controller/:action/:id', 
    :controller => 'proj',
    :requirements => {:action => /\w*/} 

  # restfulness is still borked...
  map.resources :mx, :only => [:show], :path_prefix => '/projects/:proj_id', :format => nil, :id => nil, :collection => {:invalid_codings => :get}

  map.connect "*anything",
   :controller => "application",
   :action => "index",
   :unresolvable => 'true'  
end

