module Strings

  def self.linearize(string)
    string.gsub(/\n/, '').strip
  end

  # TODO: is this used anywhere?  too convienient
  def self.remove_new_line(s)
    s.gsub(/\n/, '')
  end

  # is there another copy of this somewhere?
  def self.is_int(i)
    begin
      Integer(i)
      return true
    rescue ArgumentError
      return false
    end
  end

  def self.is_float(i)
    begin
      Float(i)
      return true
    rescue ArgumentError
      return false
    end
  end

  def self.split_on_words(text, min_word_size)
    return [] if min_word_size == 0
    if min_word_size == 1
      text.strip.split(/\s*\b\s*/)
    else
      text.strip.split(/\s*\b[\w]{1,#{min_word_size - 1}}\b\s*/)
    end
  end

  def self.word_set_fusing_adjacent(options = {})
    opt = { 
      :incoming_text => false,        # Required. String of length > 0
      :adjacent_words_to_fuse => 1    # Required. Integer (see init)
    }.merge!(options)
 
    return [] if opt[:incoming_text].size == 0 

    
    all_words = [] 
    (0..opt[:adjacent_words_to_fuse]).each do |i| 
      all_words += Strings::word_set(opt.merge!(:adjacent_words_to_fuse => i))
    end

    all_words.uniq
    
  end

  # returns an array of words from a given string
  def self.word_set(options = {})
     opt = { 
       :incoming_text => false,            # Required. String of length > 0
       :adjacent_words_to_fuse => false,   # Required. Integer (see init)
       :minimum_word_size => 1             # Required. Integer (see init)
     }.merge!(options)
  
    return [] if opt[:incoming_text].size == 0 || !opt[:adjacent_words_to_fuse]
    
    # convienience 
    t = opt[:incoming_text]
    return [] if !( t.class == String) || t.size == 0 
    
    # split the words, strip punctuation and whitespace
    # don't get words that span eliminated 
    
    wrds = []

    t.gsub!(/\-\s+/, '')  # refuse dashes at the end of the line

    t.split(/[\.\?\.\;\:]+/).each do |sentence| # we NEVER fuse terms across terminal and some punctuation (.?!;:)
      # eliminates small words by splitting on them and leaving an Array, we don't want to fuse words across fragments, when we're not fusing just split normally
      # this presently joins across commas
      if opt[:minimum_word_size] == 1
        fragments = [sentence]
      elsif opt[:minimum_word_size] > 1
        fragments = Strings::split_on_words(sentence, opt[:minimum_word_size]).reject{|w| w == "" || w == ","} 
      else
        raise
      end
    
      fragments.each do |fragment|
          tmp_wrds = fragment.split.map{|i| i.gsub(/[^A-Za-z\-\d\']/, '').strip.downcase}
          if opt[:adjacent_words_to_fuse] == 0
            wrds += tmp_wrds 
          else # fuse consecutive words
            if tmp_wrds.size >= opt[:adjacent_words_to_fuse] + 1 # we can fuse some words
              (0..(tmp_wrds.length - 1 - opt[:adjacent_words_to_fuse])).each do |i|
                wrds.push tmp_wrds[(i..(i + opt[:adjacent_words_to_fuse]))].join(" ")  
              end
            end
          end
        end # end fragment
    end # end fragments
    
    wrds.map{|w| w.strip}.uniq
  end

end
