// Create an new SVG root using 'object' (see svgweb) 
// if you pass 'body' to parentElementId object will be appended to <body>

// Usage: 
// In Rails
//   str = '<svg xmlns="http://www.w3.org/2000/svg" id="myRect8" width="100" height="100"><rect x="5" y="5" id="myRect4" rx="3" ry="10" width="15" height="15" fill="purple" stroke="yellow" stroke-width="2"/></svg>'
//   page.call 'createSvgObjRoot', (request.xml_http_request? ? 'ajax' : 'http'), 'body', 'myroot', str, 500, 500
// In mx
//   page.call 'createSvgObjRoot', (request.xml_http_request? ? 'ajax' : 'http'), *figure.svgObjRoot_params(:thumb)

function createSvgObjRoot(context, parentElementId, id, svgTag, width, height) {
  // as called in mx this never recieves undefined to context 
  if (context === 'http' || context == 'ajax') {
    var obj = document.createElement('object', true);
    obj.setAttribute('type', 'image/svg+xml');
    obj.setAttribute('id', id); 
    obj.setAttribute('data', 'data:image/svg+xml,' + svgTag); // <svg xmlns="http://www.w3.org/2000/svg">' + my_string + '</svg>');

    if (context == 'http') {  // attach it to an onload
      window.onsvgload = function() {
        svgweb.appendChild(obj, parentObj(parentElementId)); 
      }

    } else {  // javsacript is already loaded, just append 
      svgweb.appendChild(obj, parentObj(parentElementId)); 
    }

  } else {
    alert('internal error, createSvgObjRoot improperly called, contact an admin')
  }

}

// The functions below are for notes purposes, not yet integrated in mx

// toggles b/w body or an Element
function parentObj(parentElementId) {
  if (parentElementId == 'body') {
    return document.body 
  } else {
    return document.getElementById(parentElementId);
  }
}

// if you pass 'body' to parentElementId object will be appended to <body>
function createSvgRoot(parentElementId, rootId, width, height) {
  var svg = document.createElementNS(svgns, 'svg'); 
  svg.setAttribute('id', rootId);
  svg.setAttribute('width', width);
  svg.setAttribute('height', height);
  svgweb.appendChild(svg, parentObj(parentElementId)); 
}


// if you pass 'body' to parentElementId object will be appended to <body>
function addPath(parentNodeId, id, d, fill, stroke, strokeWidth ) {
  var doc = document.getElementById(parentNodeId);
  var path = document.createElementNS(svgns, 'path'); 
  path.setAttribute('id', id);
  path.setAttribute('d', d);
  path.setAttribute('fill', fill);
  path.setAttribute('stroke', stroke);
  path.setAttribute('stroke-width', strokeWidth);
  doc.appendChild(path);
}

// pass a string
function removeElement(elementId) {
  var obj = document.getElementById(elementId);
  obj.parentNode.removeChild(obj); 
}

// replace teh data attribute of an <object> tag
function updateSvgObjRoot(id, svgTag) {
  var obj = document.getElementById(id)
  obj.setAttribute('data', 'data:image/svg+xml,' + svgTag); // like <svg xmlns="http://www.w3.org/2000/svg">' + my_string + '</svg>';
}

// append element
function append_path(elementId, svgString) {
  var frag = document.createDocumentFragment(true);
  var circle = document.createElementNS(svgns, 'circle');

  circle.setAttribute('x', 10);
  circle.setAttribute('y', 10);
  circle.setAttribute('r', 5);
  circle.setAttribute('fill', 'red');

  // obj.setAttribute('data', 'data:image/svg+xml,' + svgString);

  frag.appendChild(circle)

    // svg = document.getElementById(elementId)
    // var obj = document.createElement('object', true);
    // obj.setAttribute('type', 'image/svg+xml');
    // obj.setAttribute('id', 'testid');
    // obj.setAttribute('width', '20');
    // obj.setAttribute('height', '20');
    alert('appending!');
  var svg = document.getElementsByTagNameNS(svgns, 'svg')[0];

    alert(svg);
  svg.appendChild(frag); // DocumentFragment disappears leaving circles

  // svg.appendChild(obj);
}
