require File.dirname(__FILE__) + '/../test_helper'

class Obo2mxTest < ActiveSupport::TestCase

  def setup
    set_before_filter_vars
    @proj = Proj.find($proj_id) 
  end

  def setup_for_OBO_related_tests
    ObjectRelationship.create!(:interaction => "is_a")
    ObjectRelationship.create!(:interaction => "part_of")
    @proj.reload
    @of = Obo2mx::terms_from_obo(:file => File.read(File.dirname(__FILE__) + '/../fixtures/test_files/cell.obo'), :proj_id => $proj_id)

  end
  
  test "terms_from_obo" do
    setup_for_OBO_related_tests
    assert @of 
    assert_equal 1030, @of.size 
    assert_equal "cell", @of[0][:label].name
    assert_equal 2, @of[0][:tags].size
    assert_equal 0, @of[0][:ontology_relationships].size
    assert_equal 1, @of[2][:ontology_relationships].size
    
    assert_equal @of[10][:part], @of[ @of[1][:ontology_relationships].first[:ontology_class2_index]   ][:part]
  end

end
