# == Schema Information
# Schema version: 20090930163041
#
# Table name: ontologies
#
#  id         :integer(4)      not null, primary key
#  part1_id   :integer(4)      not null
#  part2_id   :integer(4)      not null
#  isa_id     :integer(4)      not null
#  notes      :text
#  proj_id    :integer(4)      not null
#  creator_id :integer(4)      not null
#  updator_id :integer(4)      not null
#  updated_on :timestamp       not null
#  created_on :timestamp       not null
#

require File.dirname(__FILE__) + '/../test_helper'

class OntologyTest < Test::Unit::TestCase

  def setup
    set_before_filter_vars # sets $person_id = 1, $proj_id = 1
    @proj = Proj.find($proj_id) 
  end

  def setup_for_OBO_related_tests
    ObjectRelationship.create!(:interaction => "is_a")
    ObjectRelationship.create!(:interaction => "part_of")
    @proj.reload
    @of = Ontology.terms_from_obo(:file => File.read(File.dirname(__FILE__) + '/../fixtures/test_files/cell.obo'), :proj_id => $proj_id)
  end
 
  # TODO: refactor 
  def dont_test_self_terms_from_obo
    setup_for_OBO_related_tests
    assert @of  
    assert_equal 1030, @of.size 
    assert_equal "cell", @of[0][:label].name
    assert_equal 2, @of[0][:tags].size
    assert_equal 0, @of[0][:ontologies].size
    assert_equal 1, @of[2][:ontologies].size
    assert_equal @of[10][:label], @of[ @of[1][:ontologies].first[:part2_index]   ][:part]
  end

end
    
